rtsetparams(44100, 2)
/*
	0 = wavey
	1 = subtle
	2 = drone
	3 = windy
*/

srand()
print_off()

// load insts
load("./RTcmix/libs/libPANECHO.so")
load("./RTcmix/libs/libBUTTER.so")
load("./RTcmix/libs/libWAVETABLE.so")
load("./RTcmix/libs/libHALFWAVE.so")
load("./RTcmix/libs/libMSAXOFONY.so")
load("./RTcmix/libs/libSTRUMFB.so")
load("./RTcmix/libs/libSYNC.so")
load("./RTcmix/libs/libFREEVERB.so")
load("./RTcmix/libs/libIIR.so")


// bus_configs
bus_config("WAVETABLE", "aux 0 out")
bus_config("PANECHO", "aux 0 in", "out 0-1")
bus_config("SYNC", "aux 2-3 out")
bus_config("BUTTER", "aux 2-3 in", "out 0-1")
bus_config("STRUMFB", "aux 4 out")
bus_config("FREEVERB", "aux 4 in", "out 0-1")

// general vars
basepch = 7.05
basemove = { -2, -3, 2, 3 }

// wavey setup
Wampenv = maketable("line", 1000, 0,0, 1,1, 2,0)
Wamp = 2000
Wpch1s = { 0.00, 0.02, 0.03, 0.05, 0.07, 0.10, 0.12 }
Wlpch1s = len(Wpch1s)
Wpch2s = { 0.00, 0.02, 0.04, 0.05, 0.07, 0.09, 0.12 }
Wlpch2s = len(Wpch2s)
Wpdev = 0.0019

Wwave = maketable("wave", 1000, 1, random(), random(), random()*0.5, random()*0.2)

// subtle setup
Sampenv = maketable("line", 1000, 0,0, 1,1, 3,1, 7,1, 10,0)
Samp = 1000
Spch1s = { 0.00, 0.02, 0.03, 0.05, 0.07, 0.12 }
Slpch1s = len(Spch1s)
Spch2s = { 0.00, 0.02, 0.04, 0.05, 0.07, 0.10, 0.12 }
Slpch2s = len(Spch2s)
Spdev = 0.0021
Spmarks = { 0, 0, 0, 0, 0, 0, 0 }

Swave = maketable("wave", 1000, "sine")
Scross = 4
Snnotes = 4

// drone setup
Dampenv = maketable("line", 1000, 0,0, 1,1, 2,0)
Damp = 5000

Dwave = maketable("wave", 1000, 1, random(), random()*0.5, random()*0.1, random()*0.1)

Dw1 = maketable("wave3", 1000, 0.5, 1, 0)
Dw2 = maketable("wave3", 1000, 0.5, 1, 180)

Dfeedback_freq = makerandom("linear", 1.0, 50, 1000)
Ddistortion_gain = 34
Dfeedback_gain = 0.1
Dvfreq = 2.1
Dvibamp = 0.007
Dvibfreq = makerandom("even", 1.0, Dvfreq-1, Dvfreq+1)
Dvibfreq1 = makerandom("even", 1.0, Dvfreq-1, Dvfreq+1)
Dvibfreq2 = makerandom("even", 1.0, Dvfreq-1, Dvfreq+1)
Dvibfreq3 = makerandom("even", 1.0, Dvfreq-1, Dvfreq+1)
Dvibpitch =  makeLFO("sine", Dvibfreq, 0.0, Dvibamp)
Dvibpitch1 =  makeLFO("sine", Dvibfreq1, 0.0, Dvibamp)
Dvibpitch2 =  makeLFO("sine", Dvibfreq2, 0.0, Dvibamp)
Dvibpitch3 =  makeLFO("sine", Dvibfreq3, 0.0, Dvibamp)
Dpdev = 0.0017

// windy setup
Tamp = 1000
Tampenv = maketable("line", 1000, 0, 0, 1,1, 2,0.2, 4,0)


// the loop
jump = 0
for (st = 0; st < 3000; st += jump) {
   if (random() < 0.1) {
      mbase = midipch(basepch)
      mbase += basemove[trand(0, len(basemove))]
      basepch = pchmidi(mbase)
      if (basepch > 8.00) basepch -= 1.00
      if (basepch < 7.00) basepch += 1.00
   }
	MARKst = st
	ALGO = trand(0, 4)

	// wavey
	if (ALGO == 0) {
		if (random() < 0.5) {
			Wpset = Wpch1s
			Wlpset = Wlpch1s
		} else {
		Wpset = Wpch2s
		Wlpset = Wlpch2s
		}

		if (random() < 0.5)
			Wwave = maketable("wave", 1000, 1, random(), random(), random()*0.5, random()*0.2)

		Wnnotes = trunc(trand(1, 4))
		for (Wi = 0; Wi < Wnnotes; Wi += 1) {
			Wpch = basepch + Wpset[trand(0, Wlpset)]
			Wdur = irand(10, 25)
			WAVETABLE(st, Wdur, Wamp*Wampenv, Wpch, 0, Wwave)
			WAVETABLE(st, Wdur, Wamp*Wampenv, Wpch+irand(0, Wpdev), 0, Wwave)
			WAVETABLE(st, Wdur, Wamp*Wampenv, Wpch+irand(0, Wpdev), 0, Wwave)
			WAVETABLE(st, Wdur, Wamp*Wampenv, Wpch+irand(0, Wpdev), 0, Wwave)
		}

		jump = irand(7, 21)
		dur = Wdur
	} // wavey
 	// subtle
	if (ALGO == 1) {
		Sdur = irand(10, 21)
		if (random() < 0.5) {
			Spset = Spch1s
			Slpset = Slpch1s
		} else {
			Spset = Spch2s
			Slpset = Slpch2s
		}

		for (Si = 0; Si < Slpset; Si +=1) Spmarks[Si] = 0

		for (Sj = 0; Sj < Snnotes; Sj += 1) {
			Sdex = trand(0, Slpset)
			while (Spmarks[Sdex] == -1)
				Sdex = trand(0, Slpset)
			Spch = basepch + Spset[Sdex]
			Spmarks[Sdex] = -1
			for (Sk = 0; Sk < Snnotes; Sk += 1) {
				Swdex = maketable("line", "nonorm", 1000, 0, irand(100, 300), irand(0.5, 1.5), irand(300, 500), 2, irand(50, 100))

				SYNC(st, Sdur+Scross, Spch+irand(0, Spdev), Samp*Sampenv, Swdex, Swave, random())
			}
		}
		dur = Sdur
		jump = dur
	} // subtle
	// drone
	if (ALGO == 2) {
		Dpch = basepch-1.0
		Ddur = irand(20, 35)

		Ddice = random()
		if (Ddice < 0.4) {
			if (random() < 0.5)
				Dwave = maketable("wave", 1000, 1, random(), random()*0.5, random()*0.1, random()*0.1)

			WAVETABLE(st, Ddur, 0.5*Damp*Dampenv, Dpch, 0, Dwave)
			WAVETABLE(st, Ddur, 0.5*Damp*Dampenv, Dpch+irand(0, Dpdev), 0.1, Dwave)
			WAVETABLE(st, Ddur, 0.5*Damp*Dampenv, Dpch+irand(0, Dpdev), 0.9, Dwave)
			WAVETABLE(st, Ddur, 0.5*Damp*Dampenv, Dpch+irand(0, Dpdev), 1.0, Dwave)

			if (random() < 0.5) {
				Dpch += 0.07
				WAVETABLE(st, Ddur, 0.5*Damp*Dampenv, Dpch, 0, Dwave)
				WAVETABLE(st, Ddur, 0.5*Damp*Dampenv, Dpch+irand(0, Dpdev), 0.1, Dwave)
				WAVETABLE(st, Ddur, 0.5*Damp*Dampenv, Dpch+irand(0, Dpdev), 0.9, Dwave)
				WAVETABLE(st, Ddur, 0.5*Damp*Dampenv, Dpch+irand(0, Dpdev), 1.0, Dwave)
			}
		} else if (Ddice < 0.8) {
			Dwdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
			HALFWAVE(st, Ddur, Dpch, Damp*Dampenv, Dw1, Dw2, Dwdex, 0)
			Dwdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
			HALFWAVE(st, Ddur, Dpch+irand(0, Dpdev), Damp*Dampenv, Dw1, Dw2, Dwdex, 0.1)
			Dwdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
			HALFWAVE(st, Ddur, Dpch+irand(0, Dpdev), Damp*Dampenv, Dw1, Dw2, Dwdex, 0.9)
			Dwdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
			HALFWAVE(st, Ddur, Dpch+irand(0, Dpdev), Damp*Dampenv, Dw1, Dw2, Dwdex, 1.0)

			if (random() < 0.5) {
				Dpch += 0.07
				Dwdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
				HALFWAVE(st, Ddur, Dpch, Damp*Dampenv, Dw1, Dw2, Dwdex, 0)
				Dwdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
				HALFWAVE(st, Ddur, Dpch+irand(0, Dpdev), Damp*Dampenv, Dw1, Dw2, Dwdex, 0.1)
				Dwdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
				HALFWAVE(st, Ddur, Dpch+irand(0, Dpdev), Damp*Dampenv, Dw1, Dw2, Dwdex, 0.9)
				Dwdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
				HALFWAVE(st, Ddur, Dpch+irand(0, Dpdev), Damp*Dampenv, Dw1, Dw2, Dwdex, 1.0)
			}
		} else {
			MSAXOFONY(st, Ddur, 0.3*Damp*Dampenv, cpspch(Dpch), 0.1, 0.5, 0.5, 0.5, 0.5, 0)
			MSAXOFONY(st, Ddur, 0.3*Damp*Dampenv, cpspch(Dpch+irand(0, Dpdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 0.1)
			MSAXOFONY(st, Ddur, 0.3*Damp*Dampenv, cpspch(Dpch+irand(0, Dpdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 0.9)
			MSAXOFONY(st, Ddur, 0.3*Damp*Dampenv, cpspch(Dpch+irand(0, Dpdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 1.0)

			if (random() < 0.5) {
				Dpch += 0.07
				MSAXOFONY(st, Ddur, 0.3*Damp*Dampenv, cpspch(Dpch), 0.1, 0.5, 0.5, 0.5, 0.5, 0)
				MSAXOFONY(st, Ddur, 0.3*Damp*Dampenv, cpspch(Dpch+irand(0, Dpdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 0.1)
				MSAXOFONY(st, Ddur, 0.3*Damp*Dampenv, cpspch(Dpch+irand(0, Dpdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 0.9)
				MSAXOFONY(st, Ddur, 0.3*Damp*Dampenv, cpspch(Dpch+irand(0, Dpdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 1.0)
			}
		}

		if (random() < 0.1) {
			Dpitch = basepch + 1.0
			STRUMFB(st+irand(0, 0.5*Ddur), 0.5*Ddur, Damp*Dampenv, Dpitch+Dvibpitch, Dfeedback_freq, 2, 1, 1, Ddistortion_gain, Dfeedback_gain, 0, 1)

			if (random() < 0.3) {
				Dpitch += 0.02
				STRUMFB(st+irand(0, 0.5*Ddur), 0.5*Ddur, Damp*Dampenv, Dpitch+Dvibpitch1, Dfeedback_freq, 2, 1, 1, Ddistortion_gain, Dfeedback_gain, 0, 1)
				Dpitch += 0.05
				STRUMFB(st+irand(0, 0.5*Ddur), 0.5*Ddur, Damp*Dampenv, Dpitch+Dvibpitch2, Dfeedback_freq, 2, 1, 1, Ddistortion_gain, Dfeedback_gain, 0, 1)
				Dpitch += 0.02
				STRUMFB(st+irand(0, 0.5*Ddur), 0.5*Ddur, Damp*Dampenv, Dpitch+Dvibpitch3, Dfeedback_freq, 2, 1, 1, Ddistortion_gain, Dfeedback_gain, 0, 1)
			}
		}
		jump = 0.7*Ddur
		dur = Ddur
	} // drone
	// windy
	if (ALGO == 3) {
		Tdice = random()
		if (Tdice < 0.5) Ttype = 0
		else if (Tdice < 0.7) Ttype = 1
		else Ttype = 2

		if (Ttype == 0) Tbw = 0.34
		else Tbw = 0.01

		Tnswells = irand(2, 5)
		for (Ti = 0; Ti < Tnswells; Ti += 1) {
			Tdur = irand(17, 25)
			Tbasepch = 9.07 + irand(0, 0.15)
			Tdev = 0.0
			for (Tj = 0; Tj < 20; Tj += 1) {
				Tampenv = maketable("line", 1000, 0, 0, 1,1, irand(1.1, 1.4),irand(0.3, 0.6), irand(1.5, 1.8),irand(0.5, 1.0), 2,0)
				Tfreq = cpspch(Tbasepch + Tdev)
				setup(Tfreq, Tbw*Tfreq, 1)
				NOISE(st, Tdur, Tamp*Tampenv, random())
				if ((Ttype == 0) || (Ttype == 1)) Tdev += irand(0.005, 0.015)
				else {
					Tdice = random()
					if (Tdice < 0.2) Tdev += 0.01
					else if (Tdice < 0.4) Tdev += 0.02
					else if (Tdice < 0.6) Tdev += 0.03
					else if (Tdice < 0.8) Tdev += 0.04
					else Tdev += 0.05
				}
				st += 1/20
			}
			st += irand(7, 14)
			jump = 0
		}
	} // windy


// add additional -----------------------------
	if (random() < 0.5) {
		rst = irand(MARKst, MARKst+(jump*0.7))
		AALGO = trand(0, 2)
		while (AALGO == ALGO) AALGO = trand(0, 4)

	// wavey
	if (AALGO == 0) {
		if (random() < 0.5) {
			Wpset = Wpch1s
			Wlpset = Wlpch1s
		} else {
		Wpset = Wpch2s
		Wlpset = Wlpch2s
		}

		if (random() < 0.5)
			Wwave = maketable("wave", 1000, 1, random(), random(), random()*0.5, random()*0.2)

		Wnnotes = trunc(trand(1, 4))
		for (Wi = 0; Wi < Wnnotes; Wi += 1) {
			Wpch = basepch + Wpset[trand(0, Wlpset)]
			Wdur = irand(10, 25)
			WAVETABLE(rst, Wdur, Wamp*Wampenv, Wpch, 0, Wwave)
			WAVETABLE(rst, Wdur, Wamp*Wampenv, Wpch+irand(0, Wpdev), 0, Wwave)
			WAVETABLE(rst, Wdur, Wamp*Wampenv, Wpch+irand(0, Wpdev), 0, Wwave)
			WAVETABLE(rst, Wdur, Wamp*Wampenv, Wpch+irand(0, Wpdev), 0, Wwave)
		}
	} // wavey
 	// subtle
	if (AALGO == 1) {
		Sdur = irand(10, 21)
		if (random() < 0.5) {
			Spset = Spch1s
			Slpset = Slpch1s
		} else {
			Spset = Spch2s
			Slpset = Slpch2s
		}

		for (Si = 0; Si < Slpset; Si +=1) Spmarks[Si] = 0

		for (Sj = 0; Sj < Snnotes; Sj += 1) {
			Sdex = trand(0, Slpset)
			while (Spmarks[Sdex] == -1)
				Sdex = trand(0, Slpset)
			Spch = basepch + Spset[Sdex]
			Spmarks[Sdex] = -1
			for (Sk = 0; Sk < Snnotes; Sk += 1) {
				Swdex = maketable("line", "nonorm", 1000, 0, irand(100, 300), irand(0.5, 1.5), irand(300, 500), 2, irand(50, 100))

				SYNC(rst, Sdur+Scross, Spch+irand(0, Spdev), Samp*Sampenv, Swdex, Swave, random())
			}
		}
	} // subtle
	// drone
	if (AALGO == 2) {
		Dpch = basepch-1.0
		Ddur = irand(20, 35)

		Ddice = random()
		if (Ddice < 0.4) {
			if (random() < 0.5)
				Dwave = maketable("wave", 1000, 1, random(), random()*0.5, random()*0.1, random()*0.1)

			WAVETABLE(rst, Ddur, Damp*Dampenv, Dpch, 0, Dwave)
			WAVETABLE(rst, Ddur, Damp*Dampenv, Dpch+irand(0, Dpdev), 0.1, Dwave)
			WAVETABLE(rst, Ddur, Damp*Dampenv, Dpch+irand(0, Dpdev), 0.9, Dwave)
			WAVETABLE(rst, Ddur, Damp*Dampenv, Dpch+irand(0, Dpdev), 1.0, Dwave)

			if (random() < 0.5) {
				Dpch += 0.07
				WAVETABLE(rst, Ddur, Damp*Dampenv, Dpch, 0, Dwave)
				WAVETABLE(rst, Ddur, Damp*Dampenv, Dpch+irand(0, Dpdev), 0.1, Dwave)
				WAVETABLE(rst, Ddur, Damp*Dampenv, Dpch+irand(0, Dpdev), 0.9, Dwave)
				WAVETABLE(rst, Ddur, Damp*Dampenv, Dpch+irand(0, Dpdev), 1.0, Dwave)
			}
		} else if (Ddice < 0.8) {
			Dwdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
			HALFWAVE(rst, Ddur, Dpch, Damp*Dampenv, Dw1, Dw2, Dwdex, 0)
			Dwdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
			HALFWAVE(rst, Ddur, Dpch+irand(0, Dpdev), Damp*Dampenv, Dw1, Dw2, Dwdex, 0.1)
			Dwdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
			HALFWAVE(rst, Ddur, Dpch+irand(0, Dpdev), Damp*Dampenv, Dw1, Dw2, Dwdex, 0.9)
			Dwdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
			HALFWAVE(rst, Ddur, Dpch+irand(0, Dpdev), Damp*Dampenv, Dw1, Dw2, Dwdex, 1.0)

			if (random() < 0.5) {
				Dpch += 0.07
				Dwdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
				HALFWAVE(rst, Ddur, Dpch, Damp*Dampenv, Dw1, Dw2, Dwdex, 0)
				Dwdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
				HALFWAVE(rst, Ddur, Dpch+irand(0, Dpdev), Damp*Dampenv, Dw1, Dw2, Dwdex, 0.1)
				Dwdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
				HALFWAVE(rst, Ddur, Dpch+irand(0, Dpdev), Damp*Dampenv, Dw1, Dw2, Dwdex, 0.9)
				Dwdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
				HALFWAVE(rst, Ddur, Dpch+irand(0, Dpdev), Damp*Dampenv, Dw1, Dw2, Dwdex, 1.0)
			}
		} else {
			MSAXOFONY(rst, Ddur, 0.3*Damp*Dampenv, cpspch(Dpch), 0.1, 0.5, 0.5, 0.5, 0.5, 0)
			MSAXOFONY(rst, Ddur, 0.3*Damp*Dampenv, cpspch(Dpch+irand(0, Dpdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 0.1)
			MSAXOFONY(rst, Ddur, 0.3*Damp*Dampenv, cpspch(Dpch+irand(0, Dpdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 0.9)
			MSAXOFONY(rst, Ddur, 0.3*Damp*Dampenv, cpspch(Dpch+irand(0, Dpdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 1.0)

			if (random() < 0.5) {
				Dpch += 0.07
				MSAXOFONY(rst, Ddur, 0.3*Damp*Dampenv, cpspch(Dpch), 0.1, 0.5, 0.5, 0.5, 0.5, 0)
				MSAXOFONY(rst, Ddur, 0.3*Damp*Dampenv, cpspch(Dpch+irand(0, Dpdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 0.1)
				MSAXOFONY(rst, Ddur, 0.3*Damp*Dampenv, cpspch(Dpch+irand(0, Dpdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 0.9)
				MSAXOFONY(rst, Ddur, 0.3*Damp*Dampenv, cpspch(Dpch+irand(0, Dpdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 1.0)
			}
		}

		if (random() < 0.1) {
			Dpitch = basepch + 1.0
			STRUMFB(rst+irand(0, 0.5*Ddur), 0.5*Ddur, Damp*Dampenv, Dpitch+Dvibpitch, Dfeedback_freq, 2, 1, 1, Ddistortion_gain, Dfeedback_gain, 0, 1)

			if (random() < 0.3) {
				Dpitch += 0.02
				STRUMFB(rst+irand(0, 0.5*Ddur), 0.5*Ddur, Damp*Dampenv, Dpitch+Dvibpitch1, Dfeedback_freq, 2, 1, 1, Ddistortion_gain, Dfeedback_gain, 0, 1)
				Dpitch += 0.05
				STRUMFB(rst+irand(0, 0.5*Ddur), 0.5*Ddur, Damp*Dampenv, Dpitch+Dvibpitch2, Dfeedback_freq, 2, 1, 1, Ddistortion_gain, Dfeedback_gain, 0, 1)
				Dpitch += 0.02
				STRUMFB(rst+irand(0, 0.5*Ddur), 0.5*Ddur, Damp*Dampenv, Dpitch+Dvibpitch3, Dfeedback_freq, 2, 1, 1, Ddistortion_gain, Dfeedback_gain, 0, 1)
			}
		}
	} // drone
	// windy
	if (AALGO == 3) {
		Tdice = random()
		if (Tdice < 0.5) Ttype = 0
		else if (Tdice < 0.7) Ttype = 1
		else Ttype = 2

		if (Ttype == 0) Tbw = 0.34
		else Tbw = 0.01

		Tnswells = irand(4, 7)
		for (Ti = 0; Ti < Tnswells; Ti += 1) {
			Tdur = irand(17, 25)
			Tbasepch = 9.07 + irand(0, 0.15)
			Tdev = 0.0
			for (Tj = 0; Tj < 20; Tj += 1) {
				Tampenv = maketable("line", 1000, 0, 0, 1,1, irand(1.1, 1.4),irand(0.3, 0.6), irand(1.5, 1.8),irand(0.5, 1.0), 2,0)
				Tfreq = cpspch(Tbasepch + Tdev)
				setup(Tfreq, Tbw*Tfreq, 1)
				NOISE(rst, Tdur, Tamp*Tampenv, random())
				if ((Ttype == 0) || (Ttype == 1)) Tdev += irand(0.005, 0.015)
				else {
					Tdice = random()
					if (Tdice < 0.2) Tdev += 0.01
					else if (Tdice < 0.4) Tdev += 0.02
					else if (Tdice < 0.6) Tdev += 0.03
					else if (Tdice < 0.8) Tdev += 0.04
					else Tdev += 0.05
				}
				rst += 1/20
			}
			rst += irand(7, 14)
		}
	} // windy
	}
}

PANECHO(0, 0, st, 1, 0.14, 0.34, 0.78, 7, 0)

cf = makerandom("even", 0.05, 100, 500)
mcf = makefilter(cf, "smooth", 100)

bw = makerandom("even", 0.07, -0.7, -0.4)
mbw = makefilter(bw, "smooth", 100)

BUTTER(0, 0, st+7, 0.7, "bandpass", 1, 1, 0, 0, 0, mcf, mbw)
BUTTER(0, 0, st+7, 0.7, "bandpass", 1, 1, 1, 1, 0, mcf, mbw)

FREEVERB(0, 0, st, 0.035, 1.0, 0, 3, 90, 0, 100, 100)

