rtsetparams(44100, 2)

print_off()
srand()

load("./RTcmix/libs/libWAVETABLE.so")
load("./RTcmix/libs/libHALFWAVE.so")
load("./RTcmix/libs/libMSAXOFONY.so")
load("./RTcmix/libs/libSTRUMFB.so")
load("./RTcmix/libs/libFREEVERB.so")

bus_config("STRUMFB", "aux 0 out")
bus_config("FREEVERB", "aux 0 in", "out 0-1")

ampenv = maketable("line", 1000, 0,0, 1,1, 2,0)
amp = 6500

wave = maketable("wave", 1000, 1, random(), random()*0.5, random()*0.1, random()*0.1)

w1 = maketable("wave3", 1000, 0.5, 1, 0)
w2 = maketable("wave3", 1000, 0.5, 1, 180)

feedback_freq = makerandom("linear", 1.0, 50, 1000)
distortion_gain = 34
feedback_gain = 0.1
vfreq = 2.1
vibamp = 0.007
vibfreq = makerandom("even", 1.0, vfreq-1, vfreq+1)
vibfreq1 = makerandom("even", 1.0, vfreq-1, vfreq+1)
vibfreq2 = makerandom("even", 1.0, vfreq-1, vfreq+1)
vibfreq3 = makerandom("even", 1.0, vfreq-1, vfreq+1)
vibpitch =  makeLFO("sine", vibfreq, 0.0, vibamp)
vibpitch1 =  makeLFO("sine", vibfreq1, 0.0, vibamp)
vibpitch2 =  makeLFO("sine", vibfreq2, 0.0, vibamp)
vibpitch3 =  makeLFO("sine", vibfreq3, 0.0, vibamp)

basepch = 6.07
basemove = { -2, -3, 2, 3 }
pdev = 0.0017

jump = 0
for (st = 0; st < 3000; st += jump) {
	if (random() < 0.3) {
		mbase = midipch(basepch)
		mbase += basemove[trand(0, len(basemove))]
		basepch = pchmidi(mbase)
		if (basepch > 6.11) basepch -= 1.00
		if (basepch < 5.10) basepch += 1.00
	}
	pch = basepch
	dur = irand(20, 35)

dice = random()
if (dice < 0.4) {
	if (random() < 0.5)
		wave = maketable("wave", 1000, 1, random(), random()*0.5, random()*0.1, random()*0.1)

	WAVETABLE(st, dur, amp*ampenv, pch, 0, wave)
	WAVETABLE(st, dur, amp*ampenv, pch+irand(0, pdev), 0.1, wave)
	WAVETABLE(st, dur, amp*ampenv, pch+irand(0, pdev), 0.9, wave)
	WAVETABLE(st, dur, amp*ampenv, pch+irand(0, pdev), 1, wave)

	if (random() < 0.5) {
		pch += 0.07
		WAVETABLE(st, dur, amp*ampenv, pch, 0, wave)
		WAVETABLE(st, dur, amp*ampenv, pch+irand(0, pdev), 0.1, wave)
		WAVETABLE(st, dur, amp*ampenv, pch+irand(0, pdev), 0.9, wave)
		WAVETABLE(st, dur, amp*ampenv, pch+irand(0, pdev), 1, wave)
	}
} else if (dice < 0.8) {
	wdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
	HALFWAVE(st, dur, pch, amp*ampenv, w1, w2, wdex, 0)
	wdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
	HALFWAVE(st, dur, pch+irand(0, pdev), amp*ampenv, w1, w2, wdex, 0.1)
	wdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
	HALFWAVE(st, dur, pch+irand(0, pdev), amp*ampenv, w1, w2, wdex, 0.9)
	wdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.2, 1.7), irand(0.5, 0.9), 2, irand(0.05, 0.1))
	HALFWAVE(st, dur, pch+irand(0, pdev), amp*ampenv, w1, w2, wdex, 1.0)

	if (random() < 0.5) {
		pch += 0.07
		wdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.5, 1.5), irand(0.5, 0.9), 2, irand(0.05, 0.1))
		HALFWAVE(st, dur, pch, amp*ampenv, w1, w2, wdex, 0)
		wdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.5, 1.5), irand(0.5, 0.9), 2, irand(0.05, 0.1))
		HALFWAVE(st, dur, pch+irand(0, pdev), amp*ampenv, w1, w2, wdex, 0.1)
		wdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.5, 1.5), irand(0.5, 0.9), 2, irand(0.05, 0.1))
		HALFWAVE(st, dur, pch+irand(0, pdev), amp*ampenv, w1, w2, wdex, 0.9)
		wdex = maketable("line", "nonorm", 1000, 0, irand(0.1, 0.3), irand(0.5, 1.5), irand(0.5, 0.9), 2, irand(0.05, 0.1))
		HALFWAVE(st, dur, pch+irand(0, pdev), amp*ampenv, w1, w2, wdex, 1.0)
	}
} else {
	MSAXOFONY(st, dur, 0.4*amp*ampenv, cpspch(pch), 0.1, 0.5, 0.5, 0.5, 0.5, 0)
	MSAXOFONY(st, dur, 0.4*amp*ampenv, cpspch(pch+irand(0, pdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 0.1)
	MSAXOFONY(st, dur, 0.4*amp*ampenv, cpspch(pch+irand(0, pdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 0.9)
	MSAXOFONY(st, dur, 0.4*amp*ampenv, cpspch(pch+irand(0, pdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 1)

	if (random() < 0.5) {
		pch += 0.07
		MSAXOFONY(st, dur, 0.4*amp*ampenv, cpspch(pch), 0.1, 0.5, 0.5, 0.5, 0.5, 0)
		MSAXOFONY(st, dur, 0.4*amp*ampenv, cpspch(pch+irand(0, pdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 0.1)
		MSAXOFONY(st, dur, 0.4*amp*ampenv, cpspch(pch+irand(0, pdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 0.9)
		MSAXOFONY(st, dur, 0.4*amp*ampenv, cpspch(pch+irand(0, pdev)), 0.1, 0.5, 0.5, 0.5, 0.5, 1)
	}
}

	if (random() < 0.1) {
		pitch = basepch + 2.0
		STRUMFB(st+irand(0, 0.5*dur), 0.5*dur, amp*ampenv, pitch+vibpitch, feedback_freq, 2, 1, 1, distortion_gain, feedback_gain, 0, 1)

		if (random() < 0.3) {
			pitch += 0.02
			STRUMFB(st+irand(0, 0.5*dur), 0.5*dur, amp*ampenv, pitch+vibpitch1, feedback_freq, 2, 1, 1, distortion_gain, feedback_gain, 0, 1)
			pitch += 0.05
			STRUMFB(st+irand(0, 0.5*dur), 0.5*dur, amp*ampenv, pitch+vibpitch2, feedback_freq, 2, 1, 1, distortion_gain, feedback_gain, 0, 1)
			pitch += 0.02
			STRUMFB(st+irand(0, 0.5*dur), 0.5*dur, amp*ampenv, pitch+vibpitch2, feedback_freq, 2, 1, 1, distortion_gain, feedback_gain, 0, 1)
		}
	}

	jump = 0.7*dur
}

FREEVERB(0, 0, st, 0.035, 1.0, 0, 3, 90, 0, 100, 100)

