rtsetparams(44100, 2)

print_off()
srand()

load("./RTcmix/libs/libSYNC.so")
load("./RTcmix/libs/libBUTTER.so")
load("./RTcmix/libs/libPANECHO.so")

bus_config("SYNC", "aux 0-1 out")
bus_config("BUTTER", "aux 0-1 in", "out 0-1")
bus_config("PANECHO", "aux 0 in", "out 0-1")


ampenv = maketable("line", 1000, 0,0, 1,1, 3,1, 7,1, 10,0)
amp = 1000

basepch = 7.05
basemove = { -2, -3, 2, 3 }
pch1s = { 0.00, 0.02, 0.03, 0.05, 0.07, 0.12 }
lpch1s = len(pch1s)
pch2s = { 0.00, 0.02, 0.04, 0.05, 0.07, 0.10, 0.12 }
lpch2s = len(pch2s)
pdev = 0.0021
pmarks = { 0, 0, 0, 0, 0, 0, 0 }

wave = maketable("wave", 1000, "sine")

dur = 0
cross = 4
nnotes = 4
for (st = 0; st < 3000;  st += dur) {
	dur = irand(10, 21)
	if (random() < 0.5) {
		pset = pch1s
		lpset = lpch1s
	} else {
		pset = pch2s
		lpset = lpch2s
	}

	for (i = 0; i < lpset; i +=1) pmarks[i] = 0

	if (random() < 0.3) {
		mbase = midipch(basepch)
		mbase += basemove[trand(0, len(basemove))]
		basepch = pchmidi(mbase)
		if (basepch > 7.10) basepch -= 1.00
		if (basepch < 6.08) basepch += 1.00
	}

	for (j = 0; j < nnotes; j += 1) {
		dex = trand(0, lpset)
		while (pmarks[dex] == -1)
			dex = trand(0, lpset)
		pch = basepch + pset[dex]
		pmarks[dex] = -1
		for (k = 0; k < nnotes; k += 1) {
			wdex = maketable("line", "nonorm", 1000, 0, irand(100, 300), irand(0.5, 1.5), irand(300, 500), 2, irand(50, 100))

			SYNC(st, dur+cross, pch+irand(0, pdev), amp*ampenv, wdex, wave, random())
		}
	}
}

cf = makerandom("even", 0.05, 100, 500)
mcf = makefilter(cf, "smooth", 100)

bw = makerandom("even", 0.07, -0.7, -0.4)
mbw = makefilter(bw, "smooth", 100)

BUTTER(0, 0, st+7, 0.7, "bandpass", 1, 1, 0, 0, 0, mcf, mbw)
BUTTER(0, 0, st+7, 0.7, "bandpass", 1, 1, 1, 1, 0, mcf, mbw)

PANECHO(0, 0, st, 0.1, 0.21, 0.34, 0.78, 7, 0)

