// dlooch -- dashboard ambient sound app
//		Brad Garton  October, 2007
//		http://music.columbia.edu/~brad
//		garton - at - columbia - dot - edu

// Apple widget buttons
var glassDoneButton;
var whiteInfoButton;

// vars for process management
var isLooching = null; // holds the dCMIX system process
var stillLooching = 0; // continue flag for doneLooching()
var scriptnum = 0;  // which score to run


// called when widget is loaded
function setup()
{
	glassDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hidePrefs);
	whiteInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white", showPrefs);
	if (window.widget) {
		widget.onremove = dloochKill;
	}
}


// called when the widget is flipped
function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");	// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";	// hide the front
	back.style.display="block";	// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);	// flip the widget over	

}


// called by "done" button to flip widget back
function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");	// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";		// hide the back
	front.style.display="block";	// show the front

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);	// and flip the widget back to the front
}

// called when the loochbutton is released
function lbuttonUp()
{
	document.getElementById("loochButton").src = "Images/Button.png";
}

// called when the URL longbutton #1 is released
function w1buttonUp()
{
	document.getElementById("web1Button").src = "Images/longbutton.png";
}

// called when the URL longbutton #2 is released
function w2buttonUp()
{
	document.getElementById("web2Button").src = "Images/longbutton.png";
}

// radio buttons to select script
function getRadio()
{
	theForm = document.getElementById("woof_form");

	for (i = 0; i < theForm.woof.length; i++) {
		if (theForm.woof[i].checked)
			newscriptnum = i;
	}

	if (newscriptnum != scriptnum) {
		scriptnum = newscriptnum;

		if (window.widget) {
			if (isLooching != null) {
				isLooching.cancel();

				if (scriptnum == 0) 
					isLooching = widget.system("./RTcmix/dCMIX < ./RTcmix/wavey.sco", doneLooching);
				else if (scriptnum == 1) 
					isLooching = widget.system("./RTcmix/dCMIX < ./RTcmix/subtle.sco", doneLooching);
				else if (scriptnum == 2) 
					isLooching = widget.system("./RTcmix/dCMIX < ./RTcmix/drone.sco", doneLooching);
				else if (scriptnum == 3) 
					isLooching = widget.system("./RTcmix/dCMIX < ./RTcmix/windytree.sco", doneLooching);
				else if (scriptnum == 4) 
					isLooching = widget.system("./RTcmix/dCMIX < ./RTcmix/combo.sco", doneLooching);
			}
		}
	}
}


// the main button!  "relax..." or "stopit!"
function startLooching()
{
	document.getElementById("loochButton").src = "Images/Button_down.png";
	var loochtext = document.getElementById("loochButtonText");

	if (window.widget) {
		if (isLooching != null) {
			isLooching.cancel();
			loochtext.innerText = "relax...";
			isLooching = null;
			stillLooching = 0;  // don't continue in doneLooching()
		} else {
			if (scriptnum == 0) 
				isLooching = widget.system("./RTcmix/dCMIX < ./RTcmix/wavey.sco", doneLooching);
			else if (scriptnum == 1) 
				isLooching = widget.system("./RTcmix/dCMIX < ./RTcmix/subtle.sco", doneLooching);
			else if (scriptnum == 2) 
				isLooching = widget.system("./RTcmix/dCMIX < ./RTcmix/drone.sco", doneLooching);
			else if (scriptnum == 3) 
				isLooching = widget.system("./RTcmix/dCMIX < ./RTcmix/windytree.sco", doneLooching);
			else if (scriptnum == 4) 
				isLooching = widget.system("./RTcmix/dCMIX < ./RTcmix/combo.sco", doneLooching);

			loochtext.innerText = "STOPIT!";
			stillLooching = 1;  // for doneLooching() to continue
		}
	}

}

// scripts are set to run for 50 mins or so (3000 seconds) -- this will
// retrigger if still running.  Kind of a kludge, but hey...
function doneLooching()
{
	// this will restart the looching, if we reach the end of the scripts
	if (stillLooching == 1) {
		if (scriptnum == 0) 
			isLooching = widget.system("./RTcmix/dCMIX < ./RTcmix/wavey.sco", doneLooching);
		else if (scriptnum == 1) 
			isLooching = widget.system("./RTcmix/dCMIX < ./RTcmix/subtle.sco", doneLooching);
		else if (scriptnum == 2) 
			isLooching = widget.system("./RTcmix/dCMIX < ./RTcmix/drone.sco", doneLooching);
		else if (scriptnum == 3) 
			isLooching = widget.system("./RTcmix/dCMIX < ./RTcmix/windytree.sco", doneLooching);
		else if (scriptnum == 4) 
			isLooching = widget.system("./RTcmix/dCMIX < ./RTcmix/combo.sco", doneLooching);
	}
}

// called from the longbutton #1 on the back
function goLoochURL()
{
	document.getElementById("web1Button").src = "Images/longbutton_down.png";

	widget.openURL("http://music.columbia.edu/~brad/looching/");
}

// called from the longbutton #2 on the back
function goBradURL()
{
	document.getElementById("web2Button").src = "Images/longbutton_down.png";

	widget.openURL("http://music.columbia.edu/~brad/");
}

// killall dCMIX processes if widget is removed while sound running
function dloochKill()
{
	if (window.widget) {
		if (isLooching != null) {
			isLooching.cancel();
		}
	}
}
